const path=require("path"),{readJsonOrYaml}=require("../../utils/fs"),{generateAlternativeSidebarName}=require("../../utils/sidebars"),{templatesPaths}=require("./templates"),{PAGE_TYPES,CUSTOM_REDIRECTS_FILE_NAME}=require("../../constants"),{SIDEBARS_FILE_NAME}=require("../../plugins/gatsby-source-redocly-filesystem/utils");module.exports=({graphql:a,actions:b,reporter:c})=>(`production`!==process.env.NODE_ENV&&b.createPage({path:"/dev-idp-login",component:templatesPaths.devIdpLogin,context:{}}),a(`
    {
      allContentItem {
        edges {
          node {
            id
            type
            pageId
            link
            baseLink
            sourcePath
            markdown {
              headings {
                depth
                value
                id
              }
            }
            seo {
              title
              description
              image
              keywords
              jsonLd
              lang
              siteUrl
            }
            catalogInfo {
              metadata
              apiName
              apiVersion
              title
            }
            data {
              showPrevButton
              showNextButton
              customTemplate
              customDataString
              enableToc
              tocMaxDepth
              toc {
                enable
                maxDepth
                headings {
                  depth
                  value
                  id
                }
              }
              matchPath
              apiVersions {
                definitionId
                id
                title
                isDefault
                apiId
              }
              isDefaultApiVersion
              apiVersionId
              redirectFrom
            }
          }
        }
      }
      allSidebar {
        nodes {
          pagesIds
          name
        }
      }
      siteConfig {
        contentDir
        enableToc
        tocMaxDepth
        toc {
          enable
          maxDepth
        }
      }
    }
  `).then(({data:a,errors:d})=>{if(d)throw d[0];const e=a.allContentItem.edges.map(({node:a})=>a),f=a.allSidebar.nodes,{createRedirect:g}=b,{allPagesLinks:h,allRedirects:i,wildcardRedirects:j}=createContentPages(e,f,{actions:b,reporter:c},a.siteConfig),{wildcardRedirects:k,allRedirects:l}=createCustomRedirects(a.siteConfig.contentDir,{reporter:c}),m=[...k,...j],n=[...l,...i];processSimpleRedirects(n,{createRedirect:g}),processWildcardRedirects(n,m,h,{createRedirect:g})}));function resolveSidebarNameFromPath(a,b,c,d){const e=path.resolve(path.dirname(a.sourcePath),c.sidebar),f=path.dirname(e),g=d.contentDir===f;return g&&b[0].name?b[0].name:generateAlternativeSidebarName(e)}function createContentPages(a,b,{actions:c,reporter:d},e){const{createPage:f}=c,g=[],h=[],i=[];for(let j of a){g.push(j.link);const a=j.data.customDataString?JSON.parse(j.data.customDataString):{};a.hasOwnProperty("sidebar")&&a.sidebar.includes(SIDEBARS_FILE_NAME)&&(a.sidebar=resolveSidebarNameFromPath(j,b,a,e)||void 0);let c=a.sidebar?b.find(b=>a.sidebar===b.name):void 0;c=c||b.find(a=>a.pagesIds.find(a=>j.pageId.startsWith(a.replace(/\/?\*$/,""))));const k=e.toc&&e.toc.enable,l=j.data.toc&&j.data.toc.enable,m={enable:null==l?k||!1:l,maxDepth:j.data.toc&&j.data.toc.maxDepth||e.toc&&e.toc.maxDepth,headings:j.data.toc&&j.data.toc.headings||j.markdown&&j.markdown.headings},n=m.headings&&m.headings[0]&&m.headings[0].value||null,o={id:j.id,seo:{title:n,...j.seo},pageId:j.pageId,pageBaseUrl:j.baseLink,type:j.type,toc:m,data:a,catalogInfo:j.catalogInfo,link:j.link,sidebarName:c&&c.name||"",isLanding:"/"===j.link,showPrevButton:j.data.showPrevButton,showNextButton:j.data.showNextButton,apiVersions:j.data.apiVersions,apiVersionId:j.data.apiVersionId,isDefaultApiVersion:j.data.isDefaultApiVersion};switch(j.data&&j.data.redirectFrom&&j.data.redirectFrom.forEach(a=>{const b=j.link;a&&(a.endsWith("*")?h.push({fromPath:a,toPath:b}):i.push({fromPath:a,toPath:b,isPermanent:!0,redirectInBrowser:!0}))}),j.type){case PAGE_TYPES.markdown:f({path:j.link,component:templatesPaths.simpleMarkdown,context:o,matchPath:j.data&&j.data.matchPath});break;case PAGE_TYPES.mdx:f({path:j.link,component:j.sourcePath,context:o,matchPath:j.data&&j.data.matchPath});break;case PAGE_TYPES.referenceDocsPage:case PAGE_TYPES.referenceDocsOverview:f({path:j.link,component:templatesPaths.redocOperation,context:o});break;case PAGE_TYPES.dataTemplate:f({path:j.link,component:j.data.customTemplate,context:o,matchPath:j.data&&j.data.matchPath});break;case PAGE_TYPES.referenceDocsContainerPage:break;default:d.panicOnBuild(`Unknown page type for "${j.sourcePath}"`);}}return{allPagesLinks:g,allRedirects:i,wildcardRedirects:h}}function processSimpleRedirects(a,{createRedirect:b}){for(const c of a)b({...c})}function processWildcardRedirects(a,b,c,{createRedirect:d}){const e=a.map(a=>a.fromPath);for(const f of b){const{fromPath:a,toPath:b}=f,g=a.replace("*","");for(const a of c)!a.startsWith(g)||b.startsWith(g)||e.includes(a)||d({fromPath:a,toPath:b,isPermanent:!0,redirectInBrowser:!0});d({fromPath:a,toPath:b,isPermanent:!0,redirectInBrowser:!0})}}function createCustomRedirects(a,{reporter:b}){const c=readJsonOrYaml(path.join(a,CUSTOM_REDIRECTS_FILE_NAME)),d=[],e=[];if(!c||"object"!=typeof c)return{wildcardRedirects:d,allRedirects:e};b.info("creating custom redirects");for(const f of Object.keys(c)){if(!c[f]||"object"!=typeof c[f])continue;const{to:a,type:b}=c[f]||{};a&&(f.endsWith("*")?d.push({fromPath:f,toPath:a}):e.push({fromPath:f,toPath:a,isPermanent:301===b||"301"===b,redirectInBrowser:!0}))}return{wildcardRedirects:d,allRedirects:e}}